IncredibleThings

导航

LeetCode-Two Sum

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

Naive方法:

 1 public class Solution {
 2     public int[] twoSum(int[] numbers, int target) {
 3         int[] res = new int[2];
 4         for(int i = 0; i < numbers.length; i++){
 5             for(int j = i+1; j<numbers.length; j++){
 6                 if(numbers[i]+numbers[j] == target ){
 7                     res[0] = i+1;
 8                     res[1] = j+1;
 9                     return res;
10                 }
11             }
12         }
13         return null;
14     }
15 }

复杂度:O(n^2)  Submission Result: Time Limit Exceeded

 

用HashMap:

 1 public class Solution {
 2     public int[] twoSum(int[] numbers, int target) {
 3         HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
 4         int[] res =new int[2]; 
 5         for (int i = 0; i < numbers.length ; i++){
 6             if(map.containsKey(target-numbers[i])){
 7                 res[0] = map.get(target-numbers[i])+1;
 8                 res[1] = i+1;
 9                 return res;
10             }
11             map.put(numbers[i], i);
12         }
13         return null;
14         
15         
16     }
17 }

时间复杂度O(n)

 

posted on 2015-04-16 05:05  IncredibleThings  阅读(127)  评论(0编辑  收藏  举报